SystemOrganization addCategory: #'BalloonTests-Collections'!

TestCase subclass: #PointArrayTest
	instanceVariableNames: 'pointArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BalloonTests-Collections'!

!PointArrayTest commentStamp: 'tbn 3/25/2011 15:06' prior: 0!
SUnit Test for PointArray!

!PointArrayTest methodsFor: 'running' stamp: 'hjo 1/15/2011 19:54'!
setUp 

	super setUp.
	pointArray := PointArray with: 0@0 with: 10@3! !

!PointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 10:13'!
testAt

	self assert: 0@0 equals: (pointArray at: 1).
	self assert: 10@3 equals: (pointArray at: 2)
	! !

!PointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 10:14'!
testAtPut

	pointArray at: 2 put: -1 @ -1.
	self assert: 0 @ 0 equals: (pointArray at: 1).
	self assert: -1 @ -1 equals: (pointArray at: 2)
	! !

!PointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 11:54'!
testAtPutFloat

	pointArray at: 2 put: 1.2 @ 5.5.
	self assert: 1 @ 5 equals: (pointArray at: 2)
	! !

!PointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 11:56'!
testAtPutFraction

	pointArray at: 2 put: 1/2 @ 51/5.
	self assert: 0 @ 10 equals: (pointArray at: 2)
	! !

!PointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 12:05'!
testAtPutInt4

	pointArray at: 2 put: 405933 @ -405933.
	self assert: 405933@ -405933 equals: (pointArray at: 2)
	! !

!PointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 11:59'!
testAtPutLargeInteger

	self should:  [pointArray at: 2 put: 123456789012345678901234567890@987654323456787654378989] raise: Error.	! !

!PointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 10:15'!
testBounds

	self assert: (0@0 corner: 10@3) equals: pointArray bounds
		! !

!PointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 10:15'!
testDefaultElement

	self assert: 0@0 equals: pointArray defaultElement
		! !

!PointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 10:16'!
testSize

	self assert: 2 equals: pointArray size
		! !

TestCase subclass: #ShortIntegerArrayTest
	instanceVariableNames: 'shortIntegerArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BalloonTests-Collections'!

!ShortIntegerArrayTest commentStamp: 'tbn 3/25/2011 15:07' prior: 0!
SUnit Test for ShortIntegerArray!

!ShortIntegerArrayTest methodsFor: 'running' stamp: 'hjo 1/17/2011 00:55'!
setUp 

	super setUp.
	shortIntegerArray := ShortIntegerArray with: 4 with: 4+256 with: 2 with: 1+(256*10).
! !

!ShortIntegerArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 10:16'!
testAt

	self assert: 2  equals: (shortIntegerArray at: 3)
	! !

!ShortIntegerArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 10:16'!
testAtPut

	shortIntegerArray at: 3 put: 100.
	self assert: 100  equals: (shortIntegerArray at: 3)
	! !

!ShortIntegerArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 10:18'!
testSetUp

	self assert: 4 equals: (shortIntegerArray at:1) . 
	self assert: 4+256 equals: (shortIntegerArray at:2).
	self assert: 2 equals: (shortIntegerArray at:3).
	self assert: 1+(256*10) equals: (shortIntegerArray at:4).
! !

!ShortIntegerArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 10:20'!
testSwapBytePairs

	shortIntegerArray swapBytePairsHacky.
	self assert: 4*256 equals: (shortIntegerArray at:1). 
	self assert: 4*256 + 1 equals: (shortIntegerArray at:2).
	self assert: 2*256 equals: (shortIntegerArray at:3).
	self assert: 1*256 + 10 equals: (shortIntegerArray at:4).
! !

!ShortIntegerArrayTest methodsFor: 'testing' stamp: 'hjo 1/26/2011 19:34'!
testWriteBigEndianOn

	|stream|
	stream := WriteStream on: Array new.
	shortIntegerArray write: (12 bitShift: 24)+(34 bitShift: 16)+(56 bitShift: 8)+78 bigEndianOn: stream.
	self assert: #(12 34 56 78) equals: stream contents! !

!ShortIntegerArrayTest methodsFor: 'testing' stamp: 'hjo 1/26/2011 19:34'!
testWriteLittleEndianOn

	|stream|
	stream := WriteStream on: Array new.
	shortIntegerArray write: (12 bitShift: 24) +(34 bitShift: 16)+(56 bitShift: 8)+78 littleEndianOn: stream.
	self assert: #(56 78 12 34) equals: stream contents! !

TestCase subclass: #ShortPointArrayTest
	instanceVariableNames: 'pointArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BalloonTests-Collections'!

!ShortPointArrayTest commentStamp: 'tbn 3/25/2011 15:07' prior: 0!
SUnit Test for ShortPointArray!

!ShortPointArrayTest methodsFor: 'running' stamp: 'hjo 1/17/2011 12:04'!
setUp 

	super setUp.
	pointArray := ShortPointArray with: 0@0 with: 10@3! !

!ShortPointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 12:03'!
testAt

	self assert: 0@0 equals: (pointArray at: 1).
	self assert: 10@3 equals: (pointArray at: 2)
	! !

!ShortPointArrayTest methodsFor: 'testing' stamp: 'hjo 1/25/2011 22:37'!
testAtPut

	pointArray at: 2 put: -1 @ -1.
	self assert: 0 @ 0 equals: (pointArray at: 1).
	self assert: -1 @ -1 equals: (pointArray at: 2)
	! !

!ShortPointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 12:03'!
testAtPutFloat

	pointArray at: 2 put: 1.2 @ 5.5.
	self assert: 1 @ 5 equals: (pointArray at: 2)
	! !

!ShortPointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 12:03'!
testAtPutFraction

	pointArray at: 2 put: 1/2 @ 51/5.
	self assert: 0 @ 10 equals: (pointArray at: 2)
	! !

!ShortPointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 12:06'!
testAtPutInt4

	"This is the difference between PointArray"
	self should: [pointArray at: 2 put: 405933 @ -405933.] raise: Error
	! !

!ShortPointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 12:03'!
testAtPutLargeInteger

	self should:  [pointArray at: 2 put: 123456789012345678901234567890@987654323456787654378989] raise: Error.	! !

!ShortPointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 12:03'!
testBounds

	self assert: (0@0 corner: 10@3) equals: pointArray bounds
		! !

!ShortPointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 12:03'!
testDefaultElement

	self assert: 0@0 equals: pointArray defaultElement
		! !

!ShortPointArrayTest methodsFor: 'testing' stamp: 'hjo 1/17/2011 12:03'!
testSize

	self assert: 2 equals: pointArray size
		! !

TestCase subclass: #ShortRunArrayTest
	instanceVariableNames: 'shortRunArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BalloonTests-Collections'!

!ShortRunArrayTest commentStamp: 'tbn 3/25/2011 15:07' prior: 0!
SUnit Test for ShortRunArray!

!ShortRunArrayTest methodsFor: 'running' stamp: 'hjo 1/26/2011 12:29'!
setUp

	super setUp.
	shortRunArray := ShortRunArray newFrom: {1 . 1 . 1 . 2 . 3 . 3 . 1 . 1 . 10 . 10 . 10 . 10 . 10 . 10 . 10}! !

!ShortRunArrayTest methodsFor: 'testing' stamp: 'hjo 1/26/2011 12:26'!
testAt

	self assert: 1  equals: (shortRunArray at: 2).
	self assert: 2  equals: (shortRunArray at: 4).
	self assert: 3  equals: (shortRunArray at: 6).! !

!ShortRunArrayTest methodsFor: 'testing' stamp: 'hjo 1/26/2011 12:29'!
testCompressionRatio

	self assert: 1.5  equals: shortRunArray compressionRatio.! !

!ShortRunArrayTest methodsFor: 'testing' stamp: 'hjo 1/26/2011 12:31'!
testDo

	| sum |
	sum := 0.
	shortRunArray do: [:each| sum := sum + each ].
	self assert: 83 equals: sum.
! !

!ShortRunArrayTest methodsFor: 'testing' stamp: 'hjo 1/26/2011 12:37'!
testLengthAndValuesDo

	| lengthSum valueSum |
	lengthSum := 0.
	valueSum := 0.
	shortRunArray lengthsAndValuesDo: [:length :value| 
		lengthSum := lengthSum + length.
		valueSum := valueSum + value.
		 ].
	self assert: 3+ 1 + 2 + 2 + 7 equals: lengthSum.
	self assert: 1 + 2 + 3 + 1 + 10 equals: valueSum.! !

!ShortRunArrayTest methodsFor: 'testing' stamp: 'hjo 1/26/2011 12:34'!
testLengthAtRun

	self assert: 3 equals: (shortRunArray lengthAtRun: 1).
	self assert: 1 equals: (shortRunArray lengthAtRun: 2).
	self assert: 2 equals: (shortRunArray lengthAtRun: 3).
	self assert: 2 equals: (shortRunArray lengthAtRun: 4).
	self assert: 7 equals: (shortRunArray lengthAtRun: 5).! !

!ShortRunArrayTest methodsFor: 'testing' stamp: 'hjo 1/26/2011 12:49'!
testSize

	self assert: 15 equals: shortRunArray size.
! !

!ShortRunArrayTest methodsFor: 'testing' stamp: 'hjo 1/26/2011 12:57'!
testSwapRun

	| swapped |
	swapped := shortRunArray swapRuns.
	self assert:  #(3 1 1 2 2 2 2 7 7 7 7 7 7 7 7 7 7) equals: swapped asArray.! !

!ShortRunArrayTest methodsFor: 'testing' stamp: 'hjo 1/26/2011 13:01'!
testValueAtRun

	self assert: 1 equals: (shortRunArray valueAtRun: 1).
	self assert: 2 equals: (shortRunArray valueAtRun: 2).
	self assert: 3 equals: (shortRunArray valueAtRun: 3).
	self assert: 1 equals: (shortRunArray valueAtRun: 4).
	self assert: 10 equals: (shortRunArray valueAtRun: 5).! !

!ShortRunArrayTest methodsFor: 'testing' stamp: 'hjo 1/26/2011 13:05'!
testValuesCollect

	self assert: (ShortRunArray newFrom: {2 . 2 . 2 . 4 . 6 . 6 . 2 . 2 . 20 . 20 . 20 . 20 . 20 . 20 . 20}) equals: (shortRunArray valuesCollect: [:value| value * 2]).
! !

!ShortRunArrayTest methodsFor: 'testing' stamp: 'hjo 1/26/2011 13:07'!
testValuesDo

	| count |
	count := 0.
	shortRunArray valuesCollect: [:value| count := count + 1].
	self assert: 5 equals: count.
! !
